/*   ORDONARE (SORTARE)
 * 	  
 *   Algoritmul: Sortare prin Selectia Minimului (Selection Sort)
 * 
 *   Ideea: Pentru fiecare pozitie i = [1... n - 1]
 *          - cautam pozitia pmin a minimului in intervalul [i...n]
 *          - interschimbam a[i] cu a[pmin]
 * 
 *   Complexitatea algoritmului: O(n^2)
 */ 
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("selection_sort.in");
ofstream fout("selection_sort.out");

const int Dim = 10001;

int a[Dim], n;

void CitesteSir();
void SorteazaSir();
void AfiseazaSir();


int main()
{
	CitesteSir();
	SorteazaSir();
	AfiseazaSir();
	
	return 0;
}

void SorteazaSir()  // O(n * n)
{
	int pmin; // pozitia minimului in intervalul de pozitii [i ... n]
	
	for (int i = 1; i < n; ++i)
	{
		pmin = i;
		
		for (int j = i + 1; j <= n; ++j)
			if (a[j] < a[pmin])
				pmin = j;
		
		if (i != pmin)
			swap(a[i], a[pmin]);
	}
}

void AfiseazaSir()
{
	for (int i = 1; i <= n; ++i)
		fout << a[i] << ' ';
}

void CitesteSir()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
		fin >> a[i];
}


