// Time Complexity: O(n * sqrt(vmax) + n * n),
// aprox = O(n * sqrt(vmax))

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("sortare_divizori.in");
ofstream fout("sortare_divizori.out");

const int Dim = 1001;

int a[Dim]; 
int nr_div[Dim];  // nr_div[i] = numarul de divizori ai lui a[i]
int n;       

int NrDiv(int n);

int main()
{
	// Citirea datelor (Operatiile de intrare - Input Operations)
	fin >> n;
	for (int i = 1; i <= n; ++i) // O(n * sqrt(vmax))
	{
		fin >> a[i];
		nr_div[i] = NrDiv(a[i]); // O(sqrt(vmax))  - vmax = 1e9
	}
	
	// Ordonare dupa doua criterii
	// Ordonare descrecretoare dupa nr de divizori
	// si al acelasi nr de divizori, crescator dupa valoare (a[i])
	
	for (int i = 1; i < n; ++i) // O(n * n)
		for (int j = i + 1; j <= n; ++j)
			if (nr_div[i] < nr_div[j]) ||
				(nr_div[i] == nr_div[j] && a[i] > a[j]))
			{
				swap(a[i], a[j]);
				swap(nr_div[i], nr_div[j]);
			}
			
	// Afisare (Operatiile de Iesire - Output Operations)
	
	for (int i = 1; i <= n; ++i)
		fout << a[i] << ' ';
	
	
	return 0;
}

int NrDiv(int n) // O(sqrt(n))
{
	int nr_div {0};
	int d;
	for (d = 1; d * d < n; ++d)
		if (n % d == 0)
			nr_div += 2;
	
	if (d * d == n)
		nr_div++;
		
	return nr_div;
}
